// INIHandler.cpp

#include "stdafx.h"
#include "INIHandler.h"

////////////////////////////////////////////////////////////////////////////////
#ifndef WIN32 // for unix
////////////////////////////////////////////////////////////////////////////////
#include "Linux/ini_parser.h"

/*
void WritePrivateProfileString(const char* section, const char* key, const char* word, const char* path)
{
}

void GetPrivateProfileString(const char* section, const char* key, const char* defaultWord, char* out,
							 int size, const char* path)
{
}
*/


CINIHandler::CINIHandler(){
	GetModuleFileName((HINSTANCE)GetModuleHandle(NULL), MyPath, sizeof(MyPath));
	
//	strcpy(MyPath, g_programFileName);
	strrmblank(MyPath);
	char* pPathExt = YGetPathExtension(MyPath);
	if(pPathExt){
		*pPathExt = '\0';
		strcat(MyPath, "ini");
	}
	else{
		strcat(MyPath, ".ini");
	}

}
CINIHandler::CINIHandler(const char *filename)
{
	strcpy(MyPath, filename);

}
CINIHandler::~CINIHandler(){
}

void CINIHandler::Write(const char* section, const char* key, const char* word){
	ReadWriteIniKeyValueStringA(section, key, word, MyPath, true);
}
void CINIHandler::Read(const char* section, const char* key, char* word, DWORD size){
	unsigned int strLength;
	ReadWriteIniKeyValueStringA(section, key, "", MyPath, false, word);
	strrmblank(word); //

//	printf("Readed: %s, %s, %s\n", section, key, word); // debug
}

////////////////////////////////////////////////////////////////////////////////
#else // WIN32
////////////////////////////////////////////////////////////////////////////////

// [̃uNL͂
static void strrmblank(char *text)
{
	int n=0, i=0;
	while(text[n] == ' ' || text[n] == '\t' || text[n] == '\r') n++;
	if(n!=0) do{text[i++] = text[n];} while(text[n++] != '\0');
	n = strlen(text)-1;
	while(n) {
		if(text[n] == ' ' || text[n] == '\t' || text[n] == '\r') text[n] = '\0';
		else break;
		n--;
	}

}
// gqi.̂jւ̃|C^Ԃ
static char* YGetPathExtension(const char* pathText){
	char* ret = NULL;
	int len = strlen(pathText);
	while(len-->0){
		if(pathText[len] == '\\' || pathText[len] == '/') break; // gqɓ{ꂪȂȂ炱ł悢
		else if(pathText[len] == '.'){
			ret = (char*) (&pathText[len+1]);
			break;
		}
	}
	return ret;
}

CINIHandler::CINIHandler(){
	GetModuleFileName((HINSTANCE)GetModuleHandle(NULL), MyPath, sizeof(MyPath));
	strrmblank(MyPath);
	char* pPathExt = YGetPathExtension(MyPath);
	if(pPathExt){
		*pPathExt = '\0';
		strcat(MyPath, "ini");
	}
	else{
		strcat(MyPath, ".ini");
	}
}
CINIHandler::CINIHandler(const char *filename)
{
	strcpy(MyPath, filename);
}
CINIHandler::~CINIHandler(){
}

void CINIHandler::Write(const char* section, const char* key, const char* word){
	WritePrivateProfileString(section, key, word, MyPath);
}
void CINIHandler::Read(const char* section, const char* key, char* word, DWORD size){
	GetPrivateProfileString(section, key, "", word, size, MyPath);
}

#endif

void CINIHandler::WriteInt(const char* section, const char* key, const int d){
	char word[128];
	sprintf(word, "%d", d);
	Write(section, key, word);
}
int CINIHandler::ReadInt(const char* section, const char* key){
	char buf[128];
	Read(section, key, buf, 128);
	return (atoi(buf));
}
void CINIHandler::WriteFloat(const char* section, const char* key, const float d){
	char word[128];
	sprintf(word, "%.2f", d);
	Write(section, key, word);
}
float CINIHandler::ReadFloat(const char* section, const char* key){
	char buf[128];
	Read(section, key, buf, 128);
	return (atof(buf));
}
CINIHandler INI;
